import '../utils/map_helper.dart';

import '../query_state.dart';
import 'document_command_builders.dart';
import 'document_query_builders.dart';

class DocumentQueryBuilder {
  final QueryState queryState;

  DocumentQueryBuilder(this.queryState);

  Stream<T> getDoc<T>(JsonMapper<T> jsonMapper) {
    return documentQueryGetDoc(this.queryState).map((json) => jsonMapper(json));
  }

  Stream<Map<String, dynamic>> getDocMap() {
    return documentQueryGetDoc(this.queryState);
  }

  Stream<Map<String, dynamic>> getDocSnapMap() {
    return documentQueryGetDocSnap(this.queryState);
  }

  Stream<T> getDocSnap<T>(JsonMapper<T> jsonMapper) {
    return documentQueryGetDocSnap(this.queryState)
        .map((json) => jsonMapper(json));
  }

  Future<void> update(Map<String, dynamic> obj, [merge = true]) {
    return documentCommandUpdate(this.queryState, obj, merge);
  }

  DocumentQueryBuilder overrideAppState(Map<String, dynamic> overridenState) {
    this.queryState.overrideAppState(overridenState);
    return this;
  }
}
